<template>
    <div class="mainpage">
        <title>NvTweeter</title>
        <b-form-input
            id="searchBar"
            size="sm"
            class="mr-sm-2"
            placeholder="Search (#)Hashtag or (@)Person"
            v-model="tag"
            @change="publicationByTag()">
        </b-form-input>
        
        <div id="lpanel">
            <!-- get user list-->
            <b-table Borderless Fixed hover :items="eachUser" :fields="fieldsUser" thead-class="d-none">
                 <template #cell(avatar)="data" >
                    <img :src="require('@/assets/img/' + data.item.avatar)" id="avatar" alt="loupe" @click.prevent="publicationByTag(data.item.login_user)" v-bind:style="{cursor: selectedCursor}" >
                    <b-icon v-if="isLogin" icon="trash-fill" @click="unFollowSomeone(data)" v-bind:style="{cursor: selectedCursor}"></b-icon>
                </template>
            </b-table> 
            
        </div>

        <div id="container">
            <div v-if="isLogin" id="nvPubli">
                <div id="content">
                    <textarea id="editor" @input="MarkdownToHtml('editor')" placeholder="What's on your mind?"></textarea>
                    <p id="preview"> Here will be displayed your post in Markdown format </p> 
                </div>
                 <b-button id="publier" size="sm" @click="insertPubli()" class="mr-2" > Post</b-button>
            </div>

            <!-- get all publicaiton"  -->
            <b-table striped hover :items="activePublication" :fields="fieldsPublication" thead-class="d-none" >
                 <template #cell(avatar)="data">
                    <img :src="require('@/assets/img/' + data.item.avatar)" id="avatar" alt="loupe">
                </template>
                <template #cell(publication)="pub">
                    <span v-html="pub.item.publication"></span>
                    <div class="social-buttons">
                        <b-icon icon="hand-thumbs-up" @click="addLikeByClick(pub.item.id_publication)" v-bind:style="{cursor: selectedCursor}"> </b-icon>{{pub.item.likee}}
                        <b-icon icon="hand-thumbs-down" @click="addDisLikeByClick(pub.item.id_publication)" v-bind:style="{cursor: selectedCursor}"> </b-icon>{{pub.item.dislike}}

                        <!-- Another way to have like and dislike icon, using package "vue-like-dislike-buttons"
                            <vue-like-dislike-buttons
                            :likes="parseInt(pub.item.likee)"
                            :dislikes="parseInt(pub.item.dislike)"
                            @like="addLikeByClick(pub.item.id_publication)"
                            @dislike="addDisLikeByClick(pub.item.id_publication)"
                        /> 
                         -->
                        <!-- Another way to do "see post" and "retweeter" icon
                        <b-button size="sm" @click="ReTweetPostByClick(pub);" class="mr-2 retweet-button">  who reTweet</b-button> -->
                        <!-- <b-button v-if="isLogin" size="sm" @click="openShareModal(pub)" class="mr-2">  share</b-button> -->

                        <b-icon icon="chevron-double-down" @click="ReTweetPostByClick(pub);" size="is-large" v-bind:style="{cursor: selectedCursor}"></b-icon>
                        <b-icon v-if="isLogin" icon="reply" size="is-large" @click="openShareModal(pub)" v-bind:style="{cursor: selectedCursor}"></b-icon>
                    </div>
                </template>
            </b-table>
          
            <div>
                <b-modal id="retweetPost" v-model="isShow"  size="lg" title="Who retweet!" :hide-footer="true">
                    <div v-if="retweet.length==0">No new retweet!</div>
                    <div v-else>
                        <b-table striped hover :items="retweet" thead-class="d-none">
                            <template #cell(avatar)="data">
                                <img :src="require('@/assets/img/' + data.item.avatar)" id="avatar" alt="loupe">
                            </template>
                        </b-table>
                    </div>
                </b-modal>
            </div>
            <div>
                <b-modal v-model="isShowModalShare"  size="lg" title="Share!" :hide-footer="true">       
                    <textarea id="editorRetweet" v-model="retweetText" placeholder="Write a commend..."></textarea>                    
                    <b-button id="retweeter" size="sm" @click="SharePostByClick()" class="mr-2" > retweet</b-button>
                </b-modal>
            </div>
        </div>
    </div>
</template>

<script>
import { getUserById } from '../api_wrapper/api_calls.js';
import { getEveryonePublication } from '../api_wrapper/api_publication.js';
import { getUserAndEveryonePublication } from '../api_wrapper/api_user_allpublication.js';
import { getEachUser } from '../api_wrapper/api_user_list.js';
import { getUserAndHisFollower } from '../api_wrapper/api_user_follower.js';
import { getRetweetPost } from '../api_wrapper/api_retweet.js';
import { insertNewPubli } from '../api_wrapper/api_insertPubli.js';
import { addNewRetweets } from '../api_wrapper/api_addNewRetweets.js';
import { addNewReactions } from '../api_wrapper/api_addReactions.js';
import { unFollow } from '../api_wrapper/api_unFollow.js';

import { eventBus } from './event.js';
import $ from 'jquery';
import Cookies from 'js-cookie';
//import VueLikeDislikeButtons from "vue-like-dislike-buttons";


let markdown = require( "markdown" ).markdown;

    export default 
    {
        name: 'MainPage',
        components: {
             //VueLikeDislikeButtons
        },
        data() {
            return {
                login:'',
                email:'',
                password:'',
                everyPublication:[],   // stock all the post
                profilePublication:[], // stock all the post after user connected
                searchPublication: [], // for searching post according to # or @
                activePublication: [], // show the post corresponding login or not 
                eachUser:[],
                isSearch: false,
                isError:false, //show error condition with v-if
                isLogin:false,
                tag: '',
                authenInfo: '',
                retweet:[], 
                isShow:false,
                searchList:[],
                searchLogin:'',
                noTouchEver:[], //save pub, don't change ever, do forEach to get value
                //fields helps to hide or show the like and dislike field and keep their value if header is hiding
                fieldsPublication: [{key:'avatar'}, {key:'login_user'}, {key:'create_date'}, {key:'publication'}],
                fieldsUser: [{key:'avatar'}, {key:'login_user'}],
                selectedCursor: `url("data:image/svg+xml,%3csvg xmlns='http://www.w3.org/2000/svg' width='32' height='32' ...") 16 16, pointer`,
                isShowModalShare: false,
                currentPublicationId: '',
                retweetText:'',
            }
        },
        
        created() {
            
            //on : check the change signal, then activate the change
            eventBus.$on('refreshPage', (authen) => {
                this.authenInfo = authen;
                this.login = this.authenInfo.login_user;
                this.isLogin = true;
                this.userAndAllPublication();
                this.userAndfollower();
            });

            eventBus.$on('logOut', ()=>{
                //when user click on "Log Out" button, he wil be redirect to main page
                this.isLogin = false;
                this.allPublication(); 
                this.allUser();
            });

            //when user click on "Home" button, he will be redirect to login main page 
            eventBus.$on('returnHomePage', (authen) => {
                this.authenInfo = authen;
                this.login = this.authenInfo.login_user;
                this.isLogin = true;
                this.userAndAllPublication();
                this.userAndfollower();
            });
        },

        //mounted
        async mounted() {
            
            
            const userId = Cookies.get('user_id'); //return value of cookies
            const user = await getUserById(userId);
            //if there's no user login, main page shows the posts which contain @everyone and list all users
            if (user == null){
                this.allPublication(); 
                this.allUser();
            }else{
            //else main page change dynamically with the post of user's follower, all the post with @everyone and the post which had tag user
                 this.isLogin = true;
                 this.login = user.login_user;
                 this.userAndAllPublication();
                 this.userAndfollower();
            }
        },

        methods: {

            openShareModal(pub) {
                this.isShowModalShare = true;
                this.currentPublicationId = pub.item.id_publication;
            },

            //click like, add 1 like on the post, double like, remove like
            async addLikeByClick(idPublication){ 
                if (this.isLogin){
                    await addNewReactions(idPublication, Cookies.get('user_id'), 1);
                    this.userAndAllPublication();//refresh table() of post
                }
             
            },

            //click dislike, add 1 dislike on the post, double dislike, remove dislike
            async addDisLikeByClick(idPublication){ 
                 if (this.isLogin){
                    await addNewReactions(idPublication, Cookies.get('user_id'), 2);
                    this.userAndAllPublication();
                 }
            },

            //click on icon "reply", add a new rwtweet post on the post choosed
            async SharePostByClick(){
                this.addPost = await addNewRetweets(this.currentPublicationId, Cookies.get('user_id'), this.retweetText);
                this.isShowModalShare = false; //change the condition 
            },

            //click on icon "chevron-double-down", show all the rwtweet post of the post choosed
            async ReTweetPostByClick(row){
                this.retweet = await getRetweetPost(row.item.id_publication);
                this.isShow = !this.isShow;
            },

            //click on icon "trash-fill" to unfollow a user choosed
            async unFollowSomeone(data){
                this.unFollowId = data.item.id_user;
                if (this.unFollowId == Cookies.get('user_id')){
                    alert("You Can't Unfollow yourself!");
                }else{ 
                    alert("Are you sure about it?");
                    await unFollow(Cookies.get('user_id'), this.unFollowId);
                }
                
                this.userAndfollower(); //refresh follow list of user connected
                this.userAndAllPublication(); //refresh post of user connected and post of whom he follows
            },

            //insert a new post 
            async insertPubli(){
                let publication = $('#preview').html();
                publication = publication.replaceAll("<p>","<p> ");
                publication = publication.replaceAll("</p>"," </p>");
                publication = publication.replaceAll("<br>"," <br> ");
                await insertNewPubli(publication, this.login);

                this.userAndAllPublication();
            },

            //extension of Markdown
            async MarkdownToHtml(balise){
                let md_content = $('#'.concat(balise)).val();
                let html_content = markdown.toHTML(md_content);
                $('#preview').html(html_content);
            },
         
            //all the posts which contain @everyone
            async allPublication(){
                this.everyPublication = await getEveryonePublication();
                this.activePublication = this.everyPublication;
                this.noTouchEver = this.everyPublication; //fill table for searching function
                this.searchList = this.everyPublication; //update the post for searching
            },

            //the posts of user connected and the posts which contain @everyone
            async userAndAllPublication(){
                this.profilePublication = await getUserAndEveryonePublication(this.login);
                this.activePublication = this.profilePublication; //activePub is where the pubs chagne, we use it in b-table also

                this.noTouchEver = this.profilePublication; //fill table for searching function
                this.searchList = this.profilePublication; //update the post for searching

            }, 

            //all the user on the main page
            async allUser(){
                this.eachUser = await getEachUser();
            }, 
            
            //the follower of user connected
            async userAndfollower(){
                this.eachUser = await getUserAndHisFollower(this.login);
            },

            //search publicaiton base on login or not
            //userName = '' is a parameter optional
            publicationByTag: async function (userName = '') {
                if (userName !== '') this.tag = userName;

                //when there's no input in searchBar
                if(this.tag === "") {
                    this.activePublication = this.noTouchEver;
                } 
                //if there's input in searchBar, to distinguish if the input contain # or @
                else if (this.tag.includes("@") || this.tag.includes("#")){
                    let table = [];
                    //from noTouchEver table whick was filled by allPubilcation or userAndAllPublication,
                    //we do a loop for getting all the element 
                    this.noTouchEver.forEach(element => {
                        if(element.publication.toLowerCase().includes(this.tag.toLowerCase())){
                            table.push(element);
                        }
                    });

                    //showing list of post according what we put in the table
                    this.activePublication = table;

                }else{

                    //search by author name, without @ and #
                    this.searchLogin = this.tag;
                    this.activePublication = this.searchList;
                    let resultSearch = [];

                    //same as else if 
                    this.searchList.forEach(element => {
                        if(element.login_user.includes(this.tag)){
                            resultSearch.push(element);
                        }
                    });
                    this.activePublication = resultSearch;

                }
            }
        }
    }

</script>

<style>

#publier{
    width: 59vh;
    height: 4vh;
    margin:0 0 2vh 3vh; /* top right bottom left*/
    border-radius: 0.50rem;
    text-align: center;
    background-color:#91989F;
    border-color:transparent;
}

#retweeter{
    width: 65vh;
    height: 4vh;
    margin-right: 7px;
    margin-top: 5px;
    border-radius: 0.50rem;
    text-align: center;
    background-color: #91989F;
    border-color:transparent;
}

#editorRetweet{
    width: 65vh;
    height: 10vh;
    margin-right: 10px;
    resize: none;
    border-radius: 1rem; 
    text-align: center;
    border-color: #91989F;
}

#editor{
    border-color:#BDC0BA;
    width: 62vh;
    height: 15vh;
    margin-right: 7px;
    margin-bottom: 0px;
    resize: none;
    border-radius: 1rem; 
    text-align: center;

}

#preview{
    margin-left: 3vh;
    margin-bottom: 0px;
    width: 62vh;
    height: 15vh;
    background-color:#91989F;
    color: white;
    border-color:transparent;
    text-align: center;
    border-radius: 1rem;
    overflow: scroll;
}

#lpanel{
    position: fixed;
    top :15vh;
    left: 4vh;
    bottom: 5vh;
    background-color: whitesmoke;
    width: 20%;
    text-align: center;
    overflow: auto;
    border-radius: 1rem;
}

#searchBar{
    position: absolute;
    width:20%!important;
    margin-top: 18px;
    margin-left:35px;
    text-align: center;
    border-radius: 1rem;
}

::placeholder{
  color:#91989F;
  text-decoration: none;
}

#avatar{
    width: 8vh; 
    height: 8vh;
    border-radius: 50%;
}

#container {
  position: fixed;
  top :10vh;
  right: 4vh;
  bottom: 5vh;
  background-color: whitesmoke;
  width: 74%;
  margin-right:auto ;
  overflow: auto;
  border-radius: 1rem;
}

#content{
    margin:3vh 3vh 1vh 3vh;
    display: flex;
    flex: row;
}

.social-buttons {
    display: flex;
}

.retweet-button {
    margin: 0 15px 0 15px; /*top right botton left*/
}

.bi-hand-thumbs-up, .bi-hand-thumbs-down, .bi-chevron-double-down, .bi-reply, .bi-trash-fill {
    margin-top: 5px;
    margin-right: 20x;
    margin-left: 18px;
}

td{
    vertical-align: middle!important;
}
</style>